<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getRepIndexSearchListApi
} from '@/api/dataset/RepIndexSet'
import { TableData } from '@/api/reporting/RepDataProblem/RepDataProblem/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage,ElDropdown,ElDropdownMenu,ElDropdownItem } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import { Dialog } from '@/components/Dialog'
import { getWidth } from '@/utils';
import Detail from './components/Detail.vue'
import { useValidator } from '@/hooks/web/useValidator'
import { getLoginOrganCodeByUserInfo } from '@/utils/auth'
import { getOrganTree } from '@/api/common'
import { getIndexType } from '@/api/dataset/RepIndexSet';
import { transfDictList } from '@/utils';

import {useRoute} from "vue-router"
const route = useRoute();
const pageQuery = ref(route || null);
const dicid = pageQuery.value?.query?.dicid;

let frequency_param_LIST = ref([]);

//获取字典项
const getDictInfoList = async ()=>{
       const res = await getIndexType({ paramName: 'frequency_param', systemCode: 'ordb' });
       frequency_param_LIST.value = transfDictList(res.body.result);
}
getDictInfoList();

defineOptions({
  name: 'IndexSearchServiceMs',
});
const { t } = useI18n()
const { required } = useValidator();

// 获取当前用户机构号
const loginOrganCode = getLoginOrganCodeByUserInfo();
const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getRepIndexSearchListApi({
      pageIndex: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delRepDataProblemListApi(unref(ids));
    return !!res;
  },
})

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection',
    fixed: true
  },
  {
    field: 'indexsetCode',
    label: '指标集编码'
  },
  {
      field: 'indexsetName',
      label: '指标集名称'
  },
  {
    field: 'beginDate',
    label: '开始日期'
  },
  {
    field: 'endDate',
    label: '结束日期'
  },
  {
    field: 'organCode',
    label: '机构编码'
  },
  {
    field: 'frequency',
    label: '频度',
    slots:{
         default:(data)=>{
            return <span>{data.row.frequency?frequency_param_LIST.value[data.row.frequency]?.label:''}</span>
         }
    }
  },
  {
    field: 'createTime',
    label: '机构名称'
  },
  {
    field: 'tName',
    label: '数据日期'
  },
  {
    field: 'tCategory',
    label: '本期值',
    slots:{
      default:(data:any)=>{
        return <ElDropdown class="{prefixCls} custom-hover" style="vertical-align: middle;padding:0;" trigger="contextmenu" placement="right">
                  {{
                    default:()=>{
                      return <div>
                        <span class="canOperate">{data.row.tCategory}</span>
                      </div>
                    },
                    dropdown:()=>{
                      return <ElDropdownMenu>
                        <ElDropdownItem>
                          <div>按机构钻取</div>
                        </ElDropdownItem>
                        <ElDropdownItem>
                          <div>趋势分析</div>
                        </ElDropdownItem>
                      </ElDropdownMenu>
                    }
                  }}
            </ElDropdown>
      }
    }
  },
  {
    field: 'tCategory',
    label: '上期值',
    slots:{
      default:(data:any)=>{
        return <ElDropdown class="{prefixCls} custom-hover" style="vertical-align: middle;padding:0;" trigger="contextmenu" placement="right">
                  {{
                    default:()=>{
                      return <div>
                        <span>{data.row.tCategory}</span>
                      </div>
                    },
                    dropdown:()=>{
                      return <ElDropdownMenu>
                        <ElDropdownItem>
                          <div>按机构钻取</div>
                        </ElDropdownItem>
                        <ElDropdownItem>
                          <div>趋势分析</div>
                        </ElDropdownItem>
                      </ElDropdownMenu>
                    }
                  }}
            </ElDropdown>
      }
    }
  }
].map(item => ({ minWidth: item.label ? getWidth(item.label) : 120, ...item }) as TableColumn))

const searchSchema = reactive<FormSchema[]>([
  {
    field: 'orgCode',
    label: '机构',
    colProps: { span: 100 },
    componentProps: {
      checkStrictly: true,
      nodeKey: 'key',
      props: { children: 'childrens', label: 'value' },
      filterable: true,
      multiple: false,
      collapseTags: true,
      showCheckbox: true,
      // style: { minWidth: '200px' },
      //style: 'width: 100%',
      checkOnClickNode: true,
    },
    component: 'TreeSelect',
    optionApi: async () => {
      const res = await getOrganTree({
        treeid: '1',
        systemCode: 'portal',
        loginOrganCode,
      });
      return res.body.result;
    },
    value: loginOrganCode,
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'Datadate',
    label: '日期',
    componentProps: {
      type: 'date',
      valueFormat: 'YYYYMMDD',
    },
    component: 'DatePicker',
    formItemProps: {
      rules: [required()],
    },
  },
  {
    field: 'tCategory',
    label: '指标代码',
    componentProps: {},
    component: 'Input',
    formItemProps: {
      rules: [required()],
    },
  }
])

const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}
setSearchParams({indexsetType:dicid});
const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (row: TableData, type: string) => {
  let detailLoading = ElLoading.service({
    background: 'rgba(0, 0, 0, 0.7)'
  })
  const res = await queryRepDataProblemApi(row.pId)
    .catch(() => {})
    .finally(() => {
      detailLoading.close()
    })
  detailLoading.close()
  if (res) {
    const data = res.body.result
    dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
    actionType.value = type
    currentRow.value = data
    dialogVisible.value = true
  }
}

const AddAction = () => {
  dialogTitle.value = t('tableDemo.add')
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = 'add'
}
const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveRepDataProblemApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => { v.pId }) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delRepDataProblemApi(row.pId)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}
const onContextMenu = (row: any, column: any, cell: HTMLTableCellElement, event: Event) => {

}


</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="pId"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
      @cell-contextmenu="onContextMenu"
    />
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write
      v-if="actionType !== 'detail'"
      ref="writeRef"
      :current-row="currentRow"
      :action-type="actionType"
    />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>